#define M_PI 3.1415926535897932384626433832795

uniform sampler2D tex;
uniform highp vec2 center;
uniform highp float radius;
uniform highp vec2 aspect;
uniform highp vec3 redColor;
uniform highp float width;

varying highp vec4 fColor;
varying highp vec2 fTexCoord;

void main()
{
    highp vec2 uv = fTexCoord;
    highp float d = length((uv - center)*aspect);
    highp float alpha = clamp(d - radius, 0.0, width)/width;

    highp vec3 clr = redColor*texture2D(tex, uv).xyz;
    highp float power = sin(alpha*M_PI);
    clr += vec3(0.5, 0.5, 0.5)*power;
    
    highp vec3 color = texture2D(tex, uv).xyz;

    clr = mix(color, clr, alpha);
    
    gl_FragColor = vec4(clr*fColor.xyz, fColor.a);
}

