uniform sampler2D tex;

varying highp vec4 fColor;
varying highp vec2 fTexCoord;

uniform highp float fPower;

void main()
{
    highp vec4 color = texture2D(tex, fTexCoord);
    highp float bw = dot(color, vec4(0.299, 0.587, 0.114, 0.0));
    highp vec3 bwColor = vec3(bw, bw, bw);
    highp vec3 result = mix(color.xyz, bwColor, fPower);
    gl_FragColor = vec4(result, color.w)*fColor;
}

