precision highp float;

uniform sampler2D tex;
uniform vec4 tex_texelSize;

varying vec4 fColor;
varying vec2 fTexCoord;

void main()
{
    vec2 blurDirection = tex_texelSize.zw * vec2(3.0, 0.0);
    
    vec4 texel = texture2D(tex, fTexCoord);
    vec4 pixel = vec4(texel.rgb * texel.a,texel.a);
    
    texel = texture2D(tex, fTexCoord - blurDirection * 3.0);
    pixel += vec4(texel.rgb * texel.a,texel.a);
    
    texel = texture2D(tex, fTexCoord - blurDirection * 2.0);
    pixel += vec4(texel.rgb * texel.a,texel.a);
    
    texel = texture2D(tex, fTexCoord - blurDirection);
    pixel += vec4(texel.rgb * texel.a,texel.a);
    
    texel = texture2D(tex, fTexCoord + blurDirection);
    pixel += vec4(texel.rgb * texel.a,texel.a);
    
    texel = texture2D(tex, fTexCoord + blurDirection * 2.0);
    pixel += vec4(texel.rgb * texel.a,texel.a);
    
    texel = texture2D(tex, fTexCoord + blurDirection * 3.0);
    pixel += vec4(texel.rgb * texel.a,texel.a);
    
    float a = pixel.a;
    pixel *= 1.0/(a + 0.001);
    pixel.a = a * 0.2;
    
    //vec4 pixel = texture2D(tex, fTexCoord) * 0.4118;
    //pixel += texture2D(tex, fTexCoord - blurDirection * 2.0) * 0.0588;
    //pixel += texture2D(tex, fTexCoord - blurDirection * 1.0) * 0.2353;
    //pixel += texture2D(tex, fTexCoord + blurDirection * 1.0) * 0.2353;
    //pixel += texture2D(tex, fTexCoord + blurDirection * 2.0) * 0.0588;
    
    //vec4 pixel = texture2D(tex, fTexCoord) * 0.324;
    //pixel += texture2D(tex, fTexCoord - blurDirection * 3.0) * 0.0205;
    //pixel += texture2D(tex, fTexCoord - blurDirection * 2.0) * 0.0855;
    //pixel += texture2D(tex, fTexCoord - blurDirection * 1.0) * 0.2320;
    //pixel += texture2D(tex, fTexCoord + blurDirection * 1.0) * 0.2320;
    //pixel += texture2D(tex, fTexCoord + blurDirection * 2.0) * 0.0855;
    //pixel += texture2D(tex, fTexCoord + blurDirection * 3.0) * 0.0205;

    gl_FragColor = pixel;
}
