precision highp float;

uniform sampler2D tex;

varying vec4 fColor;
varying vec3 fTexCoord;

void main()
{
    float fade = clamp(fTexCoord.z, 0.0, 1.0)*0.75;
    
    vec4 pixel = texture2D(tex, fTexCoord.xy);
    float alpha = min(1.0, pixel.a * 2.0);

    float shadowPower = alpha * fade;
    vec4 shadow = vec4(0.1, 0.1, 0.1, shadowPower * fColor.a);

    gl_FragColor = shadow;
}

