precision mediump float;

//углы квада [bl]xy, [tr]zw
uniform vec4 fTexCoordMinMax;

//прогресс в процентах по горизонтали и вертикали
uniform vec2 fade;

//размеры блоков 1 / (примерное кол-во символов, кол-во строк)
uniform vec2 fadeBlocks;

uniform sampler2D tex;

varying vec2 fTexCoord;

varying vec4 fColor;

void main(void)
{
    float alpha = 0.0;

    vec2 texCoord = (fTexCoord - fTexCoordMinMax.xy) / (fTexCoordMinMax.zw - fTexCoordMinMax.xy);

    //нормализованная альфа для последнего отрезка. т.е. смотрим на прогресс как на отрезки
    vec2 p = mod(fade, fadeBlocks) / fadeBlocks;

    //получаем в каком из отрезков находится текущий фрагмент по обеим осям
    vec2 rounded = floor(texCoord / fadeBlocks) * fadeBlocks;
    
    //строчка пока не может быть видна
    if (rounded.y < fade.y)
    {
        alpha = 1.0;
    } else {
        alpha = 0.0;
        if ((abs(rounded.y) - abs(fade.y)) < 0.0001) {
            if (rounded.x < fade.x) {
                alpha = 1.0;
            } else if (rounded.x < (fade.x + fadeBlocks.x)) {
                alpha = p.x;
            }
        }
    }
    
    vec4 color = texture2D(tex, fTexCoord);
    color.a *= alpha;
    
    gl_FragColor = color*fColor;
}