precision highp float;

uniform sampler2D tex;
uniform vec4 outlineColor;
uniform vec2 outlineWidth;

varying highp vec4 fColor;
varying highp vec2 fTexCoord;

void main()
{
    vec2 uv = fTexCoord;
    vec2 size = outlineWidth;
    vec4 color = texture2D(tex, uv);
    float outline = texture2D(tex, uv + vec2(-size.x, 0)).a;
        outline += texture2D(tex, uv + vec2(0, size.y)).a;
        outline += texture2D(tex, uv + vec2(size.x, 0)).a;
        outline += texture2D(tex, uv + vec2(0, -size.y)).a;
        outline += texture2D(tex, uv + vec2(-size.x, size.y)).a;
        outline += texture2D(tex, uv + vec2(size.x, size.y)).a;
        outline += texture2D(tex, uv + vec2(-size.x, -size.y)).a;
        outline += texture2D(tex, uv + vec2(size.x, -size.y)).a;
        outline = min(outline, 1.0);
    gl_FragColor = mix(color, outlineColor, outline - color.a)*fColor;
}
